unit dbf;

{
----------------------------------------------------------------------
            Last modification : 27 May 2000 17:00
 (Please write this last modification date in your e-mails.)
----------------------------------------------------------------------

----------------------------------------------------------------------
What is TDBF
----------------------------------------------------------------------
TDbf is a TTable like component for single-user application.

It allow you to use DBF tables in your small delphi project with no need of any
big dll and without to have to install the BDE.

This is I think, the most advanced free software of this type available
for DELPHI.
   * Allow the use of all dBase native type (character, numeric,
     logical, date, and memo). <BR>
   * Memo files
   * File format compatible with Delphi Database Desktop.


Active contributors:

  * Me : Pascal GANAYE <p.ganaye@bigfoot.com>
    Please don't send any email bigger than 500ko unless prior aknowledgement
    If you prefer to write in french you should.
    Je suis francais, je parle donc parfaitement le francais.

  * Bruno Depero <bdepero@usa.net>
  * Tim Bortnik
  * Let me know if you want your name here or your email OR NOT.
    do not be shy, I receive lots of email every day if I forgot you tell me.

----------------------------------------------------------------------
How to use it ?
----------------------------------------------------------------------

1 - Copy the file in your Components directory
----------------------------------------------
Put the two files dbf.pas and dbf.dcr in your unit directory:
  C:\Program Files\Borland\Delphi5\Units
Or any other directory for exemple mine is
  D:\Delphi\Unit

2 - Install component
---------------------
In delphi click the menu 'Component' 'Install component'.
Select the file dbf.pas.
The packet is usually c:\program files\borland\delphi5\Lib\dclusr50.dpk
Compile it.
A new icon should appear in the 'DBAccess' tab of delphi.

3 - Use it
----------
Works exactly like a ttable.
In filename you enter the complete name + path of the dbf file.
At run time the program will try to find the file in this location
and same directory than the exe file.
So no need to have any alias defined anywhere

Enjoy.

Let me know any problem with it
----------------------------------------------------------------------
Main goals of this component
----------------------------------------------------------------------
  1 - WORK WITH NO BDE INSTALLATION NEEDED
BDE works fine with dbase files. If you need all power and a big program BDE is
ok. This component is an alternative when the program is small and don't want to
install BDE.

  2 - TO BE DBASE FILES COMPATIBLE
There is already some components available on the web wit various custom file
format or memory. To be DBASE compatible is a security for user to be able to
use the BDE if their program increase in size.

  3 - NOT TO DO ANYTHING
I don't want this component to became to complicated.
If I could even split it in different simplier class it would be nice.

----------------------------------------------------------------------
- TO DO LIST - Contribution welcome
----------------------------------------------------------------------
* Support for different version of DBase IV FoxPro etc...
  I try to collect as much data as possible about file format.
  It is a bit difficult to stay compatible with every version without
  messing the code.

* Indexes:
  It is very asked.
  We can do that if I got information about ndx mtx files and better algorithm
  how to insert or delete a node.
  Some memory indexes works already...
  try Procedure TDbf.FSortTable(Column:integer); if you want to see it.

* Search:
  If someone want to implement locate he is welcome.
  I think that it could be very similar to kbmtable implementation.
  Anyway it will be fully usable only when index will be done.

----------------------------------------------------------------------
HISTORY
----------------------------------------------------------------------
27 May 2000
- Split the file in different classes easier to understand and manage.
  TDbf is now the dataset but does nothing with file access.
  TPagedFile is a base class wich handle a paged fixed length file with fixed header.
- Removed (temporarly) non working function like sorting packing.

24 May 2000
- OEMToAnsi Translation
  It mean that real DBF file will be seen with more correct accent.
  A complete codepage gestion would be welcome but I have no idea of how to do
  that now.
  Thanks to Tim Bortnik for bug detection and correction.

- All file was read was read 1 car shifted wich was fine when using empty files
  but wrong with real dbf file (from a proper dbase programe).
  It was messing the DELETE flag as well also.
  I change this line : "StartData := _dataStream.Position + 2"
  If someone case say why it's 2.
  Thanks to Bruno Depero for bug detection.

23 May 2000
- Support international decimal character thanks to Bruno Depero.
- Correct a bug when a CHARACTER char is completetly filled.
  and when showing an empty string field, Some funny caracters where appearing.
- Read DBaseIV memo

21 May 2000
  First public release
----------------------------------------------------------------------
}
interface
//--------------------------------------------------------------------

uses
  Classes, Db, Windows, Forms, Controls, SysUtils, Dialogs;

type
  EBinaryDataSetError = class (Exception);
  EFieldToLongError = class (Exception);
  xBaseVersion = (xBaseIII,xBaseIV,xBaseV);

  TPagedFile = class(TObject)
  protected
    _Dbf:TDataSet;
    _Stream : TFileStream;
    _MyFieldInfos: TList;
    _HeaderSize : Cardinal;
    _RecordSize : Cardinal;
  public
    constructor Create(Parent:TDataset; const FileName: string; Mode: Word);
    destructor Destroy; override;
    property RecordSize : Cardinal read _RecordSize;

    function CalcRecordCount:Cardinal;
    procedure ReadHeader(var Buffer);
    procedure WriteHeader(const Buffer);
    procedure ReadRecord(var Buffer;IntRecNum:Integer);
    procedure WriteRecord(const Buffer;IntRecNum:Integer);
  end;

  rFileHdr = record
    VerDBF      : byte;   // 0
    Year        : byte;   // 1
    Month       : byte;   // 2
    Day         : byte;   // 3
    RecordCount : longword;  // 4-7
    FullHdrSize: word;        // 8-9
    RecordSize  : word;   // 10-11
  end;

  TDbfFile = class(TPagedFile)
  protected
    _DataHdr : rFileHdr;
    _Version : xBaseVersion;
  public
    constructor Create(Parent:TDataset; const FileName: string; Mode: Word);
    destructor Destroy; override;
    function RecordCount:Cardinal;
    property Version : xBaseVersion read _Version;
    procedure WriteHeader;
    procedure AppendRecord(const Buffer);
    procedure CreateFieldDefs(FieldDefs:TFieldDefs);
    procedure CreateTable(FieldDefs:TFieldDefs);
    procedure ClearMyFieldInfos;
    function GetFieldData(Column:Integer;DataType:TFieldType; Src,Dst: Pointer): Boolean;
    procedure SetFieldData(Column:integer;DataType:TFieldType; Src,Dst: Pointer);
  end;

  rMemoHdr = record
    NextBlock:Longint;
    Dummy : array [4..7] of byte;
    DBFFile : array [0..7] of Byte; //8..15
    bVer : Byte; //16
    Dummy2 : array [17..19] of byte;
    BlockLen:  Word;
  end;

  TMemoFile = class(TPagedFile)
  protected
    _Version:xBaseVersion;
    _MemoHdr:rMemoHdr;
  public
    constructor Create(Parent:TDataSet; const FileName: string; Mode: Word; Ver:xBaseVersion);
    procedure ReadMemo(recno:Integer;Dst:TStream);
    procedure WriteMemo(var MemoRecno:Cardinal;ReadSize:Cardinal;Src:TStream);
  end;

  TIndexFile = class(TPagedFile)
  protected
  public
  end;

  TMyFieldInfo = class
  public
    Size:Integer;
    Prec:Integer;
    Offset:Integer;
    destructor destroy;  override;
  end;

  pRecordHdr = ^tRecordHdr;
  tRecordHdr = record
    DeletedFlag : char;
  end;

  PRecInfo = ^TRecInfo;
  TRecInfo = record
    Bookmark: Longint;
    BookmarkFlag: TBookmarkFlag;
  end;

  TDbf = class(TDataSet)
  public
    _TempIndex:TList;
  protected
    _Indexes:TList;
    _dataStream: TDbfFile;   // the physical table
    _indexStream: TIndexFile;  // the physical table
    _memoStream: TMemoFile;   // the physical table
    FTableName: string;     // table path and file name

    // record data
    FRecordBufferSize : integer;  // data + housekeeping (TRecInfo)
    FRecordInfoOffset : integer;  // offset of RecInfo in record buffer
    FCurrentRecord : integer;     // current record (0 to _DataHdr.RecCount - 1)
    // status
    FIsTableOpen: Boolean;
    // field offsets in record
    //Enhancements
    fReadOnly : Boolean;
    _FilterBuffer:pchar;
  protected
    // TDataSet virtual abstract method
    function AllocRecordBuffer: PChar; override;
    procedure FreeRecordBuffer(var Buffer: PChar); override;
    procedure GetBookmarkData(Buffer: PChar; Data: Pointer); override;
    function GetBookmarkFlag(Buffer: PChar): TBookmarkFlag; override;
    function GetRecord(Buffer: PChar; GetMode: TGetMode; DoCheck: Boolean):
      TGetResult; override;
    function GetRecordSize: Word; override;
    procedure InternalAddRecord(Buffer: Pointer; Append: Boolean); override;
    procedure InternalClose; override;
    procedure InternalDelete; override;
    procedure InternalFirst; override;
    procedure InternalGotoBookmark(Bookmark: Pointer); override;
    procedure InternalHandleException; override;
    procedure InternalInitFieldDefs; override;
    procedure InternalInitRecord(Buffer: PChar); override;
    procedure InternalLast; override;
    procedure InternalOpen; override;
    procedure InternalPost; override;
    procedure InternalSetToRecord(Buffer: PChar); override;
    function IsCursorOpen: Boolean; override;
    procedure SetBookmarkFlag(Buffer: PChar; Value: TBookmarkFlag); override;
    procedure SetBookmarkData(Buffer: PChar; Data: Pointer); override;
    procedure SetFieldData(Field: TField; Buffer: Pointer); override;

    // TDataSet virtual method (optional)
    function GetRecordCount: Integer; override;
    procedure SetRecNo(Value: Integer); override;
    function GetRecNo: Integer; override;
    function GetCanModify: Boolean; override;

    procedure CloseBlob(Field: TField); override;
  public
    function CreateBlobStream(Field: TField; Mode: TBlobStreamMode): TStream; override;
    function GetFieldData(Field: TField; Buffer: Pointer): Boolean; override;

  private
    Procedure _AppendRecord(Buffer:PChar);
    procedure _OpenFiles(Create:boolean);
    procedure _CloseFiles;
    function  _FilterRecord(Buffer: PChar): Boolean;
  public
    constructor Create(AOwner:tComponent); override;
    destructor Destroy; override;
    procedure CreateTable;
  published
    property FileName: string  read FTableName write FTableName;
    property ReadOnly : Boolean read fReadOnly write fReadonly default False;
    // redeclared data set properties
    property Active;
    property Filtered;
    property BeforeOpen;
    property AfterOpen;
    property BeforeClose;
    property AfterClose;
    property BeforeInsert;
    property AfterInsert;
    property BeforeEdit;
    property AfterEdit;
    property BeforePost;
    property AfterPost;
    property BeforeCancel;
    property AfterCancel;
    property BeforeDelete;
    property AfterDelete;
    property BeforeScroll;
    property AfterScroll;
    property OnCalcFields;
    property OnDeleteError;
    property OnEditError;
    property OnFilterRecord;
    property OnNewRecord;
    property OnPostError;
  end;

  TMyBlobStream = class(TMemoryStream)
  public
    Mode: TBlobStreamMode;
    Dbf: TDBF;
    Field:TField;
    MemoRecno:Cardinal;
    ReadSize:Cardinal;
    constructor Create(ModeVal:TBlobStreamMode;DbfVal: TDbf; FieldVal:TField);
    destructor destroy;  override;
  end;



procedure Register;

//--------------------------------------------------------------------
implementation
//--------------------------------------------------------------------


Const
  dfhVersionNumber = 14;
  BofCrack = -1; // before the first record (crack)

type

  PBufArray = PCHAR;

  rAfterHdrIII = record
    Dummy   : array[12..31] of byte;
  end;

  rAfterHdrV = record
    Dummy   : array[12..67] of byte;
  end;

  rFieldHdrIII = record
    FieldName   : array[0..10] of char;
    FieldType   : char; // 11
    Dummy        : array[12..15] of byte;
    FieldSize   : byte; // 16
    FieldPrecision  : byte; //17
    dummy2      : array[18..31] of byte;
  end;

  rFieldHdrV = record
    FieldName   : array[0..10] of char;
    Dummy0        : array[11..31] of byte;
    FieldType   : char; // 32
    FieldSize   : byte; // 33
    FieldPrecision  : byte; //34
    dummy2      : array[35..47] of byte;
  end;

  rMultipleIndexHdr = record
    MdxHdr   : byte;       // 0
    Year        : byte;       // 1
    Month       : byte;       // 2
    Day         : byte;      // 3
    FileName    : array[0..15] of char; // 4..19 of byte
    BlockSize    : word; // 20 21
    BlockAdder  : word; // 22 23
    IndexFlag   : byte; // 24
    NoTag       : byte; // 25
    TagSize     : byte; // 26
    Dummy1      : byte; // 27
    TagUsed     : word; // 28..29
    Dummy2      : word; // 30..31
    NbPage      : longword; // 32..35
    FreePage    : longword; // 36..39
    BlockFree   : longword; // 40..43
    UpdYear     : byte; // 44
    UpdMonth    : byte; // 45
    UpdDay      : byte; // 46
  end;

  rMdxTag = record
    pageno      : longword; // 0..3
    tagname      : array [0..11] of char; // 4..14
    keyformat    : byte; // 15
    forwardTag1  : char; // 16
    forwardTag2 : byte; // 17
    backwardTag : byte; // 18
    dummy       : byte; // 19
    keytype     : byte; // 20
  end;
  PMdxTag = ^rMdxTag;

  rMdxTagHdr = record
    RootPage        : longint;// 0..3
    FilePages        : longint;// 4..7
    KeyFormat        : byte;   // 8
    KeyType          : char;   // 9
    dummy            : word;   // 10..11
    IndexKeyLength   : word;   // 12..13
    MaxNbKeys       : word;   // 14..15
    SecondKeyType   : word;   // 16..17
    IndexKeyItemLen  : word;   // 18..19
    dummy2           : array [20..22] of byte;
    UniqueFlag      : byte;   // 23
  end;

  PMdxTagHdr = ^rMdxTagHdr;
  PDataFieldHdrIII = ^rFieldHdrIII;
  PDataFieldHdrV = ^rFieldHdrV;

  rAfterHdrV3 = record
    Dummy   : array[12..31] of byte;
  end;

  rAfterHdrV4 = record
    Dummy   : array[12..67] of byte;
  end;

  rFieldHdrV3 = record
    FieldName   : array[0..10] of char;
    FieldType   : char; // 11
    Dummy        : array[12..15] of byte;
    FieldSize   : byte; // 16
    FieldPrecision  : byte; //17
    dummy2      : array[18..31] of byte;
  end;

  rFieldHdrV4 = record
    FieldName   : array[0..10] of char;
    Dummy0        : array[11..31] of byte;
    FieldType   : char; // 32
    FieldSize   : byte; // 33
    FieldPrecision  : byte; //34
    dummy2      : array[35..47] of byte;
  end;

// ****************************************************************************
// International separator
// thanks to Bruno Depero from Italy
function DbfStrToFloat(s:string):Extended;
var
  oDECIMALSEPARATOR:char;
  oTHOUSANDSEPARATOR:Char;
  f:Extended;
begin
  oDECIMALSEPARATOR:=DECIMALSEPARATOR;
  oTHOUSANDSEPARATOR:=THOUSANDSEPARATOR;
  try
    DECIMALSEPARATOR:='.';
    THOUSANDSEPARATOR:=#0;
    if TextToFloat(PChar(s),f,fvExtended) then Result:=f else Result:=0;
  finally
    DECIMALSEPARATOR:=oDECIMALSEPARATOR;
    THOUSANDSEPARATOR:=oTHOUSANDSEPARATOR;
  end;
end;

function FloatToDbfStr(f:Extended;size,prec:integer):string;
var
  oDECIMALSEPARATOR:char;
  oTHOUSANDSEPARATOR:Char;
  s:string;
begin
  oDECIMALSEPARATOR:=DECIMALSEPARATOR;
  oTHOUSANDSEPARATOR:=THOUSANDSEPARATOR;
  try
    DECIMALSEPARATOR:='.';
    THOUSANDSEPARATOR:=#0;
    s:=FloatToStrF(f,ffFixed,Size,prec);
    Result:=s;
  finally
    DECIMALSEPARATOR:=oDECIMALSEPARATOR;
    THOUSANDSEPARATOR:=oTHOUSANDSEPARATOR;
  end;
end;
// ****************************************************************************
// Paged stream
// Implement any Header + Fixed size records File.
// I hope it will be used for all files...
function TPagedFile.CalcRecordCount:Cardinal;
begin
  if _RecordSize = 0 then Result:=0
  else Result:=(_Stream.Size - _HeaderSize) div _RecordSize;
end;

constructor TPagedFile.Create(Parent:TDataSet; const FileName: string; Mode: Word);
begin
  _Dbf:=Parent;
  try
    _Stream:=TFileStream.Create(FileName,Mode);
  except
    _Stream:=nil;
  end;
end;

destructor TPagedFile.Destroy;
begin
  _Stream.Free;
  inherited;
end;

Procedure TPagedFile.ReadRecord(var Buffer;IntRecNum:Integer);
begin
  _Stream.Position := _HeaderSize + (_RecordSize * IntRecNum );
  _Stream.Read(Buffer,_RecordSize);
end;

procedure TPagedFile.WriteRecord(const Buffer;IntRecNum:Integer);
begin
  _Stream.Position := _HeaderSize + (_RecordSize * IntRecNum);
  _Stream.Write(Buffer, _RecordSize);
end;

procedure TPagedFile.ReadHeader(var Buffer);
begin
  _Stream.Seek(0,soFromBeginning);
  _Stream.ReadBuffer(Buffer,_HeaderSize);
end;

procedure TPagedFile.WriteHeader(const Buffer);
begin
  _Stream.Seek(0,soFromBeginning);
  _Stream.WriteBuffer (Buffer, _HeaderSize);
end;

(*
constructor TDbfIndex.Create;
begin
end;

destructor TDbfIndex.destroy;
begin
end;
*)
// get the number of records and check size

constructor TDbfFile.Create(Parent:TDataSet; const FileName: string; Mode: Word);
var
  lRecordCount:Cardinal;
begin
  inherited;
  _MyFieldInfos:=TList.Create;

  if fmCreate = Mode then begin
    FillChar(_DataHdr,sizeof(_DataHdr),0);
    _HeaderSize:=0;
    _RecordSize:=0;
    _DataHdr.VerDBF:=$04; // Default version xBaseIV without memo
  end else begin
    _Stream.Seek(0,soFromBeginning);
    _Stream.ReadBuffer (_DataHdr, SizeOf(_DataHdr));
    case _DataHdr.VerDBF of
    $03,$83:          _Version:=xBaseIII;
    $04,$8B,$8E,$7B:  _Version:=xBaseIV;
    $05 :             _Version:=xbaseV;
    else
      _Version:=xBaseIV; // My favorite...
    end;
    _HeaderSize:=_DataHdr.FullHdrSize;
    _RecordSize:=_DataHdr.RecordSize;
    lRecordCount:=CalcRecordCount;
    if _DataHdr.RecordCount <> lRecordCount then begin
      ShowMessage('Invalid Record Count,'+^M+
                                     'RecordCount in Hdr : '+IntToStr(_DataHdr.RecordCount)+^M+
                                     'expected : '+IntToStr(lRecordCount));

      _DataHdr.RecordCount := lRecordCount;
    end;
  end;
end;

destructor TDbfFile.destroy;
begin
  ClearMyFieldInfos;
  _MyFieldInfos.free;
  inherited;
end;

function TDbfFile.RecordCount:Cardinal;
begin
  Result:=_DataHdr.RecordCount;
end;

procedure TDbfFile.ClearMyFieldInfos;
var i:Integer;
begin
  for i:=0 to _MyFieldInfos.Count-1 do begin
    TMyFieldInfo(_MyFieldInfos.Items[i]).Free;
  end;
  _MyFieldInfos.Clear;
end;

procedure TDbfFile.AppendRecord(const Buffer);
begin
  Inc(_DataHdr.RecordCount);
  WriteRecord(Buffer,_DataHdr.RecordCount-1);
end;

procedure TDbfFile.WriteHeader;
var
  SystemTime: TSystemTime;
  lAfterHdrIII:rAfterHdrIII;
  lAfterHdrV:rAfterHdrV;
  n:TDateTime;
begin
  Assert(_Stream<>nil,'_dataStream=Nil');
  GetLocalTime(SystemTime);

  _DataHdr.Year := SystemTime.wYear - 1900;
  _DataHdr.Month := SystemTime.wMonth;
  _DataHdr.Day := SystemTime.wDay;
  _Stream.Seek(0,soFromBeginning);
  _Stream.WriteBuffer (_DataHdr, SizeOf(_DataHdr));

  if _Version >= xBaseV then begin
    FillChar(lAfterHdrV,SizeOf(lAfterHdrV),0);
    _Stream.WriteBuffer (lAfterHdrV, SizeOf(lAfterHdrV));
  end else begin
    FillChar(lAfterHdrIII,SizeOf(lAfterHdrIII),0);
    _Stream.WriteBuffer (lAfterHdrIII, SizeOf(lAfterHdrIII));
  end;
end;

procedure TDbfFile.CreateFieldDefs(FieldDefs:TFieldDefs);
var
  lColumnCount,lHeaderSize,lFieldSize:Cardinal;
  Il : Integer;
  lFieldOffset : Integer;
  fn:string;
  ft:TFieldType;
  fs,nfs,fd:Integer;
  MyFieldInfo:TMyFieldInfo;
  lFieldHdrIII:rFieldHdrIII;
  lFieldHdrV:rFieldHdrV;
  FieldClass: TFieldClass;

  function ToFieldType(dbasetype:char;fs,fd:Integer):TFieldType;
  begin
    case dbasetype of
    'C' :
      begin
        Result:=ftString;
      end;
    'L' :
      begin
        Result:=ftBoolean;
      end;
    'F' :
      begin
        Result:=ftFloat;
      end;
    'N' :
      begin
        if fd=0 then begin
          if fs <= 4 then begin
            Result:=ftSmallInt;
          end else if fs <= 9 then begin
            Result:=ftInteger;
          end else begin
            Result:=ftLargeInt;
          end;
        end else begin
          Result:=ftFloat;
        end;
      end;
    'D' :
      begin
        Result:=ftDate;
      end;
    'M' :
      begin
        Result:=ftMemo;
      end;
    else
      begin
        Result:=ftString;
      end;
    end; //case
  end;
begin
  ClearMyFieldInfos;

  if _Version>=xBaseV then begin
    lHeaderSize:=SizeOf(rAfterHdrV) + SizeOf(rFileHdr);
    lFieldSize:=SizeOf(rFieldHdrV);
  end else begin
    lHeaderSize:=SizeOf(rAfterHdrIII) + SizeOf(rFileHdr);
    lFieldSize:=SizeOf(rFieldHdrIII);
  end;
  lColumnCount:= (_DataHdr.FullHdrSize - lHeaderSize) div lFieldSize;

  if (lColumnCount <= 0) or (lColumnCount > 255) then
      Raise eBinaryDataSetError.Create('Invalid Field count : ' + IntToStr(lColumnCount) + ' (must be between 1 and 255)');

  lFieldOffset := 1;

  _Stream.Position := lHeaderSize;
  for Il:=0 to lColumnCount-1 do begin
    if _Version>=xBaseV then begin
      _Stream.ReadBuffer(lFieldHdrV,SizeOf(lFieldHdrV));
      fn:=PCHAR(@lFieldHdrV.FieldName[0]);
      fs:=lFieldHdrV.FieldSize;
      fd:=lFieldHdrV.FieldPrecision;
      nfs:=fs;
      ft:=ToFieldType(lFieldHdrV.FieldType,nfs,fd);
    end else begin
      _Stream.ReadBuffer(lFieldHdrIII,SizeOf(lFieldHdrIII));
      fn:=PCHAR(@lFieldHdrIII.FieldName[0]);
      fs:=lFieldHdrIII.FieldSize;
      fd:=lFieldHdrIII.FieldPrecision;
      nfs:=fs;
      ft:=ToFieldType(lFieldHdrIII.FieldType,nfs,fd);
    end;
    with FieldDefs.AddFieldDef do begin
  		Name := fn;
  		DataType := ft;
  		FieldNo:=Il;
      if DataType in [ftString,ftBCD] then begin
     		Size := fs;
        if DataType = ftBCD then Precision := fd;
      end;
    end;
    MyFieldInfo:=TMyFieldInfo.Create;
    MyFieldInfo.Offset:=lFieldOffset;
    MyFieldInfo.Size:=fs;
    MyFieldInfo.Prec:=fd;
    _MyFieldInfos.Add(MyFieldInfo);
    Inc(lFieldOffset,fs);
  end;
  if (lFieldOffset <> _DataHdr.RecordSize) then begin
    ShowMessage('Invalid Record Size,'+^M+
                                     'Record Size in Hdr : '+IntToStr(_DataHdr.RecordSize)+^M+
                                     'Expected : '+IntToStr(lFieldOffset));
    _DataHdr.RecordSize := lFieldOffset;
  end;
end;

procedure TDbfFile.CreateTable(FieldDefs:TFieldDefs);
var
  ix:Integer;
  lFieldHdrIII:rFieldHdrIII;
  lType:Char;
  lSize,lPrec:Integer;
  Offs:Integer;
  lterminator:Byte;
begin
  _Stream.Position:=SizeOf(rFileHdr) + SizeOf(rAfterHdrIII);
  Offs:=1; // deleted mark count 1.
  for Ix:=0 to FieldDefs.Count-1 do
  begin
    with FieldDefs.Items[Ix] do
    begin
      FillChar(lFieldHdrIII,SizeOf(lFieldHdrIII),#0);
      lPrec:=0;
      case DataType of
        ftString:
          begin
            ltype:='C';
            lSize := Size;
          end;
        ftBoolean:
          begin
            ltype:='L';
            lSize := 1;
          end;
        ftSmallInt:
          begin
            ltype:='N';
            lSize := 6;
          end;
        ftInteger:
          begin
            ltype:='N';
            lSize := 11;
          end;
        ftLargeInt:
          begin
            ltype:='N';
            lSize := 20;
            lPrec := 0;
          end;
        ftFloat:
          begin
            ltype:='N';
            lSize := 20;
            lPrec := 4;
          end;
        ftDate:
          begin
            ltype:='D';
            lSize := 8;
          end;
        ftMemo:
          begin
            ltype:='M';
            lSize := 10;
          end;
        else
          begin
            raise EBinaryDataSetError.Create (
             'InitFieldsDefs: Unsupported field type');
          end;
      end; // case

      lFieldHdrIII.FieldType:=ltype; //DataType;
      StrCopy(lFieldHdrIII.FieldName,PChar(FieldDefs.Items[Ix].Name));
      lFieldHdrIII.FieldSize:=lSize;
      lFieldHdrIII.FieldPrecision:=lPrec;

      _Stream.Write(lFieldHdrIII,SizeOf(lFieldHdrIII));
      Inc(Offs,lSize);
    end;
  end;
  // end of header
  lterminator := $1a;
  _Stream.Write(lterminator,SizeOf(lterminator));

  // update header
  _DataHdr.RecordSize := Offs;
  _DataHdr.FullHdrSize := _Stream.Position;

  // write the updated header
  _Stream.Position:=0;
  WriteHeader;
end;

function TDbfFile.GetFieldData(Column:Integer;DataType:TFieldType; Src,Dst: Pointer): Boolean;
var
  FieldOffset: Integer;
  FieldSize: Integer;
  s:string;
  d:TDateTime;
  ld,lm,ly:Integer;
  MyFieldInfo:TMyFieldInfo;
begin
  MyFieldInfo:=TMyFieldInfo(_MyFieldInfos[Column]);
  FieldOffset := MyFieldInfo.Offset;
  FieldSize := MyFieldInfo.Size;
  SetString(s, PChar(Src) + FieldOffset, FieldSize );
  if DataType = ftBoolean then begin
    if (s[1]='T') then Word(Dst^) := 1
    else Word(Dst^) := 0;
  end  else if DataType in [ftInteger,ftSmallInt,ftLargeInt] then begin
    ld:=StrToIntDef(s,0);
    case DataType of
    ftInteger : Integer(Dst^) := ld;
    ftSmallInt : SmallInt(Dst^) := ld;
    ftLargeint : LargeInt(Dst^) := ld;
    end;
  end  else if DataType = ftFloat then begin
    Double(Dst^) := DBFStrToFloat(s);
  end  else if DataType = ftDate then begin
    ld:=StrToIntDef(Copy(s,7,2),1);
    lm:=StrToIntDef(Copy(s,5,2),1);
    ly:=StrToIntDef(Copy(s,1,4),0);
    if ld=0 then ld:=1;
    if lm=0 then lm:=1;
    if (ly<1900) or (ly>2100) then ly:=1900;
    try
      d:=EncodeDate(ly,lm,ld);
      Integer(Dst^) := DateTimeToTimeStamp(d).Date;
    except
      Integer(Dst^) := 0;
    end;
  end  else if DataType = ftString then begin
    s:=Trim(s);
    StrPCopy(Dst,s);
    OemToChar(Dst,Dst);
  end;
  Result := True;
end;

procedure TDbfFile.SetFieldData(Column:integer;DataType:TFieldType; Src,Dst: Pointer);
var
  FieldSize,FieldPrec: Integer;
  s:string;
  li:Longint;
  fl:Double;
  da:TDateTime;
  ly,lm,ld:Word;
  ts:TTimeStamp;
  MyFieldInfo:TMyFieldInfo;
begin
  MyFieldInfo:=TMyFieldInfo(_MyFieldInfos[Column]);
  FieldSize := MyFieldInfo.Size;
  FieldPrec := MyFieldInfo.Prec;
  Dst:=PChar(Dst)+MyFieldInfo.Offset;
  if DataType = ftBoolean then begin
    if Word(Src^) = 1 then s:='T'
    else s:='F';
  end  else if DataType in [ftInteger,ftSmallInt,ftLargeInt] then begin
    case DataType of
    ftInteger : li := Integer(Src^);
    ftSmallInt : li := SmallInt(Src^);
    else li := LargeInt(Src^);
    end;
    s:=IntToStr(li);
    if Length(s)<FieldSize then s:=StringOfChar(' ',FieldSize-Length(s)) + s;
  end else if DataType = ftFloat then begin
    fl := Double(Src^);
    s:=FloatToDbfStr(fl,FieldSize,FieldPrec);
    if Length(s)<FieldSize then s:=StringOfChar(' ',FieldSize-Length(s)) + s;
  end  else if DataType = ftDate then begin
    ts.Time:=0;
    ts.Date:=Integer(Src^);
    da:=TimeStampToDateTime(ts);
    DecodeDate(da,ly,lm,ld);
    FmtStr(s,'%4d%2d%2d',[ly,lm,ld]);
  end  else if DataType = ftString then begin
    CharToOem(Src,Src);
    s:=PChar(Src); // finish with first 0
  end;
  if Length(s)<FieldSize then begin
    s:=s+StringOfChar(' ',FieldSize-Length(s));
  end else if Length(s)>FieldSize then begin
    raise eFieldToLongError.Create('Field too long :' + IntToStr(Length(s))
     + ' (must be between 1 and ' + IntToStr(FieldSize) + ').');
  end;
  Move (PChar(s)^, Dst^, FieldSize);
end;

destructor TMyFieldInfo.destroy;
begin
  inherited;
end;


constructor TMemoFile.Create(Parent:TDataSet; const FileName: string; Mode: Word; Ver:xBaseVersion);
begin
  inherited Create(Parent,FileName,Mode);
  _Version:=Ver;
  if fmCreate = Mode then begin
    FillChar(_MemoHdr,sizeof(_MemoHdr),0);
  end else begin
    _Stream.Position:=0;
    _Stream.read(_MemoHdr,SizeOf(_MemoHdr));
  end;
  _HeaderSize:=0;
  _RecordSize:=_MemoHdr.BlockLen;

  if (_RecordSize=0) or ((_RecordSize mod 128)<>0) then begin
    _MemoHdr.BlockLen := $200;
    _RecordSize := $200;
  end;
end;

procedure TMemoFile.ReadMemo(recno:Integer;Dst:TStream);
var
  Buff:array[0..4095] of char;
  i,lsize:integer;
  finish:boolean;
  lastc:char;
begin
  if recno=0 then Exit;
  _Stream.Position:= _RecordSize * recno;
  if _Version >= xBaseIV then begin // dBase4 memofiles
    _Stream.read(Buff[0],8);
    if (Buff[0]=#$ff) and  (Buff[1]=#$ff) and
      (Buff[2]=#$08) and (Buff[3]=#$00) then begin
          // dbase IV memo
      lsize:=(PInteger(@Buff[4])^)-8;
    end else begin
      lsize:=0;
    end;
    repeat
      if lsize>SizeOf(Buff) then begin
        _Stream.read(Buff,SizeOf(Buff));
        Dst.Write(buff,SizeOf(Buff));
        Dec(lsize,SizeOf(Buff));
      end else if lsize>0 then begin
        _Stream.read(Buff,lsize);
        Dst.Write(buff,lsize);
        lsize:=0;
      end;
    until lsize=0;
  end else begin
    finish:=False;
    _Stream.read(Buff,SizeOf(Buff));
    repeat
      for i:=0 to SizeOf(Buff)-2 do begin
        if ((Buff[i]=#$1A) and
          ((Buff[i+1]=#$1A) or ((i=0) and (lastc=#$1A))))
          or (Buff[i]=#$0)
          then begin
          if i>0 then Dst.Write(buff,i);
          finish:=True;
          break;
        end;
      end;
      if finish then Break;
      Dst.Write(buff,512);
      lastc:=Buff[511];
      _Stream.read(Buff,SizeOf(Buff));
    until finish;
  end;
  Dst.Seek(0,0);
end;

procedure TMemoFile.WriteMemo(var MemoRecno:Cardinal;ReadSize:Cardinal;Src:TStream);
var
  s:string;
  ByteBefore:Integer;
  ByteAfter:Integer;
  FieldOffset,FieldSize:Integer;
  Buff:array[0..511] of char;
  i:Integer;
  c:Byte;
  Append:Boolean;
begin
  if _Version >= xBaseIV then begin // dBase4 memofiles
    ByteBefore:=8;
    ByteAfter:=0;
  end else begin // stupid files
    ByteBefore:=0;
    ByteAfter:=2;
  end;
  if Src.Size = 0 then begin
    s:=StringOfChar(' ',FieldSize);
    Move (PChar(s)^, PChar(_Dbf.ActiveBuffer + FieldOffset)^, FieldSize);
  end else begin
    if ((ByteBefore+Src.Size+ByteAfter+_MemoHdr.BlockLen-1) div _MemoHdr.BlockLen)
      <= ((ReadSize+_MemoHdr.BlockLen-1) div _MemoHdr.BlockLen)
      then begin
      Append:=false;
      //MemoRecno:=MemoRecno;
    end else begin
      Append:=True;
      MemoRecno:=_MemoHdr.NextBlock;
    end;
    _Stream.Seek(_MemoHdr.BlockLen * MemoRecno,0);
    i:=Src.Position;
    Src.Seek(0,0);
    if ByteBefore=8 then begin
      i:=$0008ffff;
      _Stream.Write(i,4);
      i:=Src.Size+ByteBefore+ByteAfter;
      _Stream.Write(i,4);
    end;
    repeat
      i:=Src.Read(buff,512);
      if i=0 then break;
      Inc(_MemoHdr.NextBlock);
      _Stream.Write(Buff,i);
    until i<512;
    if ByteAfter=2 then begin
      c:=$1A;
      _Stream.Write(c,1);
      _Stream.Write(c,1);
    end;
    if Append then begin
      _Stream.Seek(0,0);
      _Stream.Write(_MemoHdr,SizeOf(_MemoHdr))
    end;
  end;
end;

// ____________________________________________________________________________
// TDbf._AppendRecord
Procedure TDbf._AppendRecord(Buffer:PChar);
begin
  InternalLast;
  (Buffer)^ := ' ';
  _dataStream.AppendRecord(Buffer^)
end;

/////////////////////////////////////////////////
////// Part I:
////// Initialization, opening, and closing
/////////////////////////////////////////////////

// ____________________________________________________________________________
// TDbf.InternalOpen
// I: open the table/file
procedure TDbf.InternalOpen;
begin
  _OpenFiles(false);
  // initialize the field definitions
  InternalInitFieldDefs;

  // if there are no persistent field objects,
  // create the fields dynamically
  if DefaultFields then
    CreateFields;
  // connect the TField objects with the actual fields
  BindFields (True);

  FCurrentRecord := BofCrack;

  FRecordInfoOffset := _dataStream.RecordSize;
  FRecordBufferSize := _dataStream.RecordSize + sizeof (TRecInfo);
  //_dataStream.SetHdr(_DataHdr.FullHdrSize,_DataHdr.RecordSize);

  // set the bookmark size
  BookmarkSize := sizeOf (Integer);

  // everything OK: table is now open

  FIsTableOpen := True;

// ShowMessage ('InternalOpen: RecCount: ' + IntToStr (_DataHdr.RecCount));
end;

// ____________________________________________________________________________
// TDbf.InternalInitFieldDefs
// I: define the fields
procedure TDbf.InternalInitFieldDefs;
begin
  FieldDefs.Clear;
  with FieldDefs do
  begin
    if _dataStream=nil then begin
      _OpenFiles(false);
      _dataStream.CreateFieldDefs(FieldDefs);
      _CloseFiles;
    end else begin
      _dataStream.CreateFieldDefs(FieldDefs);
    end;
  end;
end;


procedure TDbf._OpenFiles(Create:boolean);
var
  fileopenmode : integer;
  lIndexName,lMemoName : string;
  ff:string;
begin
  if not FileExists (FTableName) then begin
    ff:=ExtractFilePath(Application.Exename)+ExtractFileName(FTableName);
    if FileExists(ff) then FTableName:=ff;
  end;
  lIndexName:=ChangeFileExt(fTableName,'.mdx');
  lMemoName:=ChangeFileExt(fTableName,'.dbt');

  // check if the file exists
  if Create then begin
    _dataStream := TDBFFile.Create(Self,fTableName, fmCreate);
    _indexStream := TIndexFile.Create(Self,lIndexName, fmCreate);
    _memoStream := TMemoFile.Create(Self,lMemoName, fmCreate,_dataStream.Version);
  end else if not FileExists (FTableName) then begin
    raise eBinaryDataSetError.Create ('Open: Table file not found');
  end else begin
    // create a Stream for the file
    if fReadOnly or (csDesigning in ComponentState) then
      fileopenmode := fmOpenRead + fmShareDenyNone
    else
      fileopenmode := fmOpenReadWrite + fmShareDenyWrite;
    _dataStream := TDBFFile.Create(Self,fTableName, fileopenmode);

    if FileExists (lIndexName) then begin
      _indexStream := TIndexFile.Create(Self,lIndexName, fileopenmode);
      (*
      _indexStream._HeaderSize := 544;
      _indexStream._RecordSize := sizeof(rMdxTag);
      _indexStream._HeaderSize := SizeOf(rMultipleIndexHdr);
      _indexStream.ReadHeader(_IndexHdr);
      for i:= 0 to _IndexHdr.TagUsed-1 do begin
      Idx:=TDbfIndex.Create;
      //_indexStream.Seek(544 + i * _IndexHdr.TagSize ,0);
      _indexStream.ReadRecord(Idx.MdxTag,i);
      _Indexes.Add(Idx);

      BlockNo := Idx.MdxTag.pageno * (_IndexHdr.BlockAdder div _IndexHdr.BlockSize);
      //_indexStream.Seek(BlockNo  ,0);
      _indexStream.ReadRecord(Idx.MdxTagHdr,i);
      Idx.Init(self);
      end;
      *)
    end;

    if FileExists (lMemoName) then begin
      _memoStream := TMemoFile.Create(Self,lMemoName, fileopenmode,_dataStream.Version);
    end;
  end;
end;

procedure TDbf._CloseFiles;
begin
  if _dataStream=nil then exit;

  _dataStream.Free;
  _dataStream:=nil;

  _indexStream.Free;
  _indexStream:=nil;

  _memoStream.Free;
  _memoStream:=nil;

//  for i:=0 to _Indexes.Count-1 do begin
//    TDBFIndex(_Indexes[i]).Free;
//  end;
//  _Indexes.Clear;

  // free the internal list field offsets
end;

// ____________________________________________________________________________
// TDbf.InternalClose
procedure TDbf.InternalClose;
begin
  if fReadOnly or (csDesigning in ComponentState) then
  begin
    // nothing...
  end  else begin
    _dataStream.WriteHeader;
  end;

  // disconnet field objects
  BindFields (False);
  // destroy field object (if not persistent)
  if DefaultFields then
    DestroyFields;

  // close the file
  FIsTableOpen := False;
  _CloseFiles;
end;

// ____________________________________________________________________________
// TDbf.IsCursorOpen
// I: is table open
function TDbf.IsCursorOpen: Boolean;
begin
  Result := FIsTableOpen;
end;

// ____________________________________________________________________________
// TDbf.WriteHdr

// ____________________________________________________________________________
// TDbf.Create
constructor TDbf.Create(AOwner:tComponent);
begin
  inherited create(aOwner);
  _TempIndex:=TList.Create;
  _Indexes:=TList.Create;
end;

destructor TDbf.Destroy;
begin
  inherited Destroy;
  _CloseFiles; // just in case, it should be already done in 'inherited destroy'
  _TempIndex.free;
  _Indexes.free;
end;

////////////////////////////////////////
////// Part II:
////// Bookmarks management and movement
////////////////////////////////////////

// ____________________________________________________________________________
// TDbf.InternalGotoBookmark
// II: set the requested bookmark as current record
procedure TDbf.InternalGotoBookmark (Bookmark: Pointer);
var
  ReqBookmark: Integer;
begin
  ReqBookmark := PInteger (Bookmark)^;
//  ShowMessage ('InternalGotoBookmark: ' +
//    IntToStr (ReqBookmark));
  if (ReqBookmark >= 0) and (ReqBookmark < _dataStream.RecordCount) then
    FCurrentRecord := ReqBookmark
  else
    raise eBinaryDataSetError.Create ('Bookmark ' +
      IntToStr (ReqBookmark) + ' not found');
end;

// ____________________________________________________________________________
// TDbf.InternalSetToRecord
// II: same as above (but passes a buffer)
procedure TDbf.InternalSetToRecord (Buffer: PChar);
var
  ReqBookmark: Integer;
begin
//  ShowMessage ('InternalSetToRecord');
  ReqBookmark := PRecInfo(Buffer + FRecordInfoOffset).Bookmark;
  InternalGotoBookmark (@ReqBookmark);
end;

// ____________________________________________________________________________
// TDbf.GetBookmarkFlag
// II: retrieve bookmarks flags from buffer
function TDbf.GetBookmarkFlag (
  Buffer: PChar): TBookmarkFlag;
begin
//  ShowMessage ('GetBookmarkFlag');
  Result := PRecInfo(Buffer + FRecordInfoOffset).BookmarkFlag;
end;

// ____________________________________________________________________________
// TDbf.SetBookmarkFlag
// II: change the bookmark flags in the buffer
procedure TDbf.SetBookmarkFlag (Buffer: PChar;
  Value: TBookmarkFlag);
begin
//  ShowMessage ('SetBookmarkFlag');
  PRecInfo(Buffer + FRecordInfoOffset).BookmarkFlag := Value;
end;

// ____________________________________________________________________________
// TDbf.GetBookmarkData
// II: read the bookmark data from record buffer
procedure TDbf.GetBookmarkData (
  Buffer: PChar; Data: Pointer);
begin
//  ShowMessage ('GetBookmarkData: ' + IntToStr (PRecInfo(Buffer + FRecordInfoOffset).Bookmark));
  PInteger(Data)^ :=
    PRecInfo(Buffer + FRecordInfoOffset).Bookmark;
end;

// ____________________________________________________________________________
// TDbf.SetBookmarkData
// II: set the bookmark data in the buffer
procedure TDbf.SetBookmarkData (
  Buffer: PChar; Data: Pointer);
begin
//  ShowMessage ('SetBookmarkData: ' + IntToStr (PInteger(Data)^));
  PRecInfo(Buffer + FRecordInfoOffset).Bookmark :=
    PInteger(Data)^;
end;

// ____________________________________________________________________________
// TDbf.InternalFirst
// II: Go to a special position before the first record
procedure TDbf.InternalFirst;
begin
  FCurrentRecord := BofCrack;
end;

// ____________________________________________________________________________
// TDbf.InternalLast
// II: Go to a special position after the last record
procedure TDbf.InternalLast;
begin
  FCurrentRecord := _DataStream.RecordCount; // 1 too much
end;

// ____________________________________________________________________________
// TDbf.GetRecordCount
// II (optional): Record count
function TDbf.GetRecordCount: Longint;
begin
  CheckActive;
  Result := _DataStream.RecordCount;
end;

// ____________________________________________________________________________
// TDbf.GetRecNo
// II (optional): Get the number of the current record
function TDbf.GetRecNo: Longint;
begin
  UpdateCursorPos;
  if FCurrentRecord < 0 then
    Result := 1
  else
    Result := FCurrentRecord + 1;
end;

function TDbf.GetCanModify: Boolean;
begin
  result:=not FReadOnly;
end;
// ____________________________________________________________________________
// TDbf.SetRecNo
// II (optional): Move to the given record number
procedure TDbf.SetRecNo(Value: Integer);
begin
  CheckBrowseMode;
  if (Value > 1) and (Value <= _DataStream.RecordCount) then
  begin
    FCurrentRecord := Value - 1;
    Resync([]);
  end;
end;

//////////////////////////////////////////
////// Part III:
////// Record buffers and field management
//////////////////////////////////////////

// ____________________________________________________________________________
// TDbf.GetRecordSize
/// III: Determine the size of each record buffer in memory
function TDbf.GetRecordSize: Word;
begin
  Result := _dataStream.RecordSize; // data only
end;

// ____________________________________________________________________________
// TDbf.AllocRecordBuffer
/// III: Allocate a buffer for the record
function TDbf.AllocRecordBuffer: PChar;
begin
  Result := StrAlloc(FRecordBufferSize);
end;

// ____________________________________________________________________________
// TDbf.InternalInitRecord
// III: Initialize the record (set to zero)
procedure TDbf.InternalInitRecord(Buffer: PChar);
begin
  FillChar(Buffer^, FRecordBufferSize, 0);
  Buffer^ := ' ';
end;

// ____________________________________________________________________________
// TDbf.FreeRecordBuffer
// III: Free the buffer
procedure TDbf.FreeRecordBuffer (var Buffer: PChar);
begin
  StrDispose(Buffer);
end;

// ____________________________________________________________________________
// TDbf.GetRecord
// III: Retrieve data for current, previous, or next record
// (eventually moving to it) and return the status
function TDbf.GetRecord(Buffer: PChar;
  GetMode: TGetMode; DoCheck: Boolean): TGetResult;
var
  Acceptable : Boolean;
begin
  result := grOk;
  if _DataStream.RecordCount < 1 then
    Result := grEOF
  else
  repeat
    begin
      case GetMode of
        gmCurrent :
          begin
            // ShowMessage ('GetRecord Current');
            if (FCurrentRecord >= _DataStream.RecordCount) or
                (FCurrentRecord < 0) then
              Result := grError;
          end;
        gmNext :
          begin
            if (fCurrentRecord < (_DataStream.RecordCount)-1) then
              Inc (FCurrentRecord)
            else
              Result := grEOF;
          end;
        gmPrior :
          begin
            if (fCurrentRecord > 0) then
              Dec(fCurrentRecord)
            else
              Result := grBOF;
          end;
      end;
      // fill record data area of buffer
      if Result = grOK then
      begin
        if fCurrentRecord<_TempIndex.Count then begin
          _dataStream.ReadRecord(Buffer^,Integer(_TempIndex.Items[fCurrentRecord]))
        end else begin
          _dataStream.ReadRecord(Buffer^,fCurrentRecord)
        end;
        ClearCalcFields(Buffer);
        GetCalcFields(Buffer);
        with PRecInfo(Buffer + FRecordInfoOffset)^ do
        begin
          BookmarkFlag := bfCurrent;
          Bookmark := FCurrentRecord;
        end;
      end
      else
        if (Result = grError) and DoCheck then
          raise eBinaryDataSetError.Create ('GetRecord: Invalid record');
      Acceptable := (pRecordHdr(Buffer)^.DeletedFlag = ' ') and _FilterRecord(Buffer);
      if (GetMode=gmCurrent) and Not Acceptable then Result := grError;
    end;
  until (Result <> grOK) or Acceptable;
end;

function TDbf._FilterRecord(Buffer: PChar): Boolean;
var
  SaveState: TDatasetState;
begin
  Result:=True;
  if not Filtered or not Assigned(OnFilterRecord) then Exit;
  _FilterBuffer:=buffer;
  SaveState:=SetTempState(dsFilter);
  OnFilterRecord(self,Result);
  RestoreState(SaveState);
end;

// ____________________________________________________________________________
// TDbf.InternalPost
// III: Write the current data to the file
procedure TDbf.InternalPost;
begin
  CheckActive;
  if State = dsEdit then
  begin
    // replace data with new data
    _dataStream.WriteRecord(ActiveBuffer^, fCurrentRecord);
  end
  else
  begin
    // always append
    _AppendRecord(ActiveBuffer);
  end;
end;

// ____________________________________________________________________________
// TDbf.InternalAddRecord
// III: Add the current data to the file
procedure TDbf.InternalAddRecord(
  Buffer: Pointer; Append: Boolean);
begin
  // always append
  _AppendRecord(ActiveBuffer);
end;

// ____________________________________________________________________________
// TDbf.InternalDelete
// III: Delete the current record
procedure TDbf.InternalDelete;
begin
  CheckActive;
  pRecordHdr(ActiveBuffer)^.DeletedFlag := '*'; //_DataHdr.LastDeleted;
  _dataStream.WriteRecord(ActiveBuffer^,fCurrentRecord);
  Resync([]);
end;

// ____________________________________________________________________________
// TDbf.GetFieldData
// III: Move data from record buffer to field
function TDbf.GetFieldData (
  Field: TField; Buffer: Pointer): Boolean;
var
  Ptr: Pointer;
begin
  Result := False;
  if State=dsFilter then begin
    Ptr:=_FilterBuffer;
  end else begin
    if IsEmpty or (Field.FieldNo <= 0) then exit;
    Ptr := ActiveBuffer;
  end;
  if Assigned(Buffer) then begin
    Result:=_dataStream .GetFieldData(Field.FieldNo - 1,Field.DataType,Ptr,Buffer);
  end else begin
    if Field.DataType=ftBoolean then begin
      // for some reason buffer is null sometime for boolean...
      // for example when there is checkboxes
      // It mean form me that i should write in the pointer itself ??
      Result:=_dataStream .GetFieldData(Field.FieldNo - 1,Field.DataType,Ptr,@Buffer);
    end;
  end;
end;

// ____________________________________________________________________________
// TDbf.SetFieldData
// III: Move data from field to record buffer
procedure TDbf.SetFieldData(Field: TField; Buffer: Pointer);
begin
  if (Field.FieldNo >= 0) and Assigned (Buffer) then begin
    _dataStream.SetFieldData(Field.FieldNo - 1,Field.DataType,Buffer,ActiveBuffer);
    DataEvent (deFieldChange, Longint(Field));
  end;
end;


// ____________________________________________________________________________
// TDbf.CreateTable
// I: Create a new table/file
procedure TDbf.CreateTable;
var
  Ix : Integer;
begin
  CheckInactive;
  //  InternalInitFieldDefs;
  if FieldDefs.Count = 0 then
  begin
    for Ix := 0 to FieldCount - 1 do
    begin
      with Fields[Ix] do
      begin
        if FieldKind = fkData then
          FieldDefs.Add(FieldName,DataType,Size,Required);
      end;
    end;
  end;
  _OpenFiles(true);
  try
    _dataStream.CreateTable(FieldDefs);
  finally
    // close the file
    _CloseFiles;
  end;
end;
// ____________________________________________________________________________
// TDbf.InternalHandleException
// default exception handling
procedure TDbf.InternalHandleException;
begin
  // standard exception handling
  Application.HandleException(Self);
end;

procedure TDbf.CloseBlob(Field: TField);
begin
  // I do not see anything to do.
end;

function TDbf.CreateBlobStream(Field: TField; Mode: TBlobStreamMode): TStream;
var
  Memoi:array[1..32] of char;
  lBlob:TMyBlobStream;
begin
  lBlob:=TMyBlobStream.Create(Mode,Self,Field);
  if _dataStream.GetFieldData(Field.FieldNo-1, ftString, ActiveBuffer,@Memoi[1]) then begin
    lBlob.MemoRecno:=StrToIntDef(Memoi,0);
    _memoStream.ReadMemo(lBlob.MemoRecno,lBlob);
    lBlob.ReadSize:=lBlob.Size;
  end else lBlob.MemoRecno:=0;
  Result:=lBlob;
end;

constructor TMyBlobStream.Create(ModeVal:TBlobStreamMode;DbfVal: TDbf;FieldVal:TField);
begin
  Mode:=ModeVal;
  Dbf:=DbfVal;
  Field:=FieldVal;
end;

destructor TMyBlobStream.destroy;
var
  Memoi:array[1..32] of char;
  MyFieldInfo:TMyFieldInfo;
begin
  if (Mode=bmWrite) then begin
    Size:=Position; // Strange but it leave tailing trash bytes if I do not write that.
    Dbf._memoStream.WriteMemo(MemoRecno,Self.ReadSize,Self);
    Dbf._dataStream.SetFieldData(Field.FieldNo-1,ftInteger,@MemoRecno,Dbf.ActiveBuffer);
  end;
  inherited;
end;
// ____________________________________________________________________________
// ___ Experimentations _______________________________________________________
// ____________________________________________________________________________



procedure Register;
begin
  RegisterComponents('DBAccess', [TDbf]);
end;

end.

(*
// ____________________________________________________________________________
// TDbf.SortTable
// Enhancement: Sort the table by the fields passed.
Procedure TDbf.SortTable(SortFields : Array of String);

  { This is the main sorting routine. It is passed the number of elements and the
    two callback routines. The first routine is the function that will perform
    the comparison between two elements. The second routine is the procedure that
    will swap two elements if necessary } // Source: UNDU #8
  // TDbf._SwapRecords
  // Enhancement: Quick swap of two records.  Used primarily for sorting.

  procedure QSort(uNElem: Integer);
  { uNElem - number of elements to sort }

    procedure qSortHelp(pivotP: Integer; nElem: word);
    label
      TailRecursion,
      qBreak;
    var
      leftP, rightP, pivotEnd, pivotTemp, leftTemp: word;
      lNum: Integer;
      retval: integer;
    begin
      TailRecursion:
        if (nElem <= 2) then
          begin
            if (nElem = 2) then

              begin
                rightP := pivotP +1;
                if (_CompareRecords(SortFields,pivotP, rightP) > 0) then
                  _SwapRecords(pivotP, rightP);
              end;
            exit;
          end;
        rightP := (nElem -1) + pivotP;
        leftP :=  (nElem shr 1) + pivotP;
        { sort pivot, left, and right elements for "median of 3" }
        if (_CompareRecords(SortFields,leftP, rightP) > 0) then _SwapRecords(leftP, rightP);
        if (_CompareRecords(SortFields,leftP, pivotP) > 0) then _SwapRecords(leftP, pivotP)

        else if (_CompareRecords(SortFields,pivotP, rightP) > 0) then _SwapRecords(pivotP, rightP);
        if (nElem = 3) then
          begin
            _SwapRecords(pivotP, leftP);
            exit;
          end;
        { now for the classic Horae algorithm }
        pivotEnd := pivotP + 1;
        leftP := pivotEnd;
        repeat
          retval := _CompareRecords(SortFields,leftP, pivotP);
          while (retval <= 0) do
            begin
              if (retval = 0) then
                begin
                  _SwapRecords(LeftP, PivotEnd);
                  Inc(PivotEnd);
                end;
              if (leftP < rightP) then
                Inc(leftP)
              else
                goto qBreak;
              retval := _CompareRecords(SortFields,leftP, pivotP);
            end; {while}
          while (leftP < rightP) do
            begin

              retval := _CompareRecords(SortFields,pivotP, rightP);
              if (retval < 0) then
                Dec(rightP)
              else
                begin
                  _SwapRecords(leftP, rightP);
                  if (retval <> 0) then
                    begin
                      Inc(leftP);
                      Dec(rightP);
                    end;
                  break;
                end;
            end; {while}

        until (leftP >= rightP);
      qBreak:
        if (_CompareRecords(SortFields,leftP, pivotP) <= 0) then Inc(leftP);
        leftTemp := leftP -1;
        pivotTemp := pivotP;
        while ((pivotTemp < pivotEnd) and (leftTemp >= pivotEnd)) do
          begin
            _SwapRecords(pivotTemp, leftTemp);
            Inc(pivotTemp);
            Dec(leftTemp);
          end; {while}
        lNum := (leftP - pivotEnd);
        nElem := ((nElem + pivotP) -leftP);

        if (nElem < lNum) then
          begin
            qSortHelp(leftP, nElem);
            nElem := lNum;
          end
        else
          begin
            qSortHelp(pivotP, lNum);
            pivotP := leftP;
          end;
        goto TailRecursion;
      end; {qSortHelp }

  begin
    if (uNElem < 2) then  exit; { nothing to sort }
    qSortHelp(1, uNElem);
  end; { QSort }

var
  t:longint;
begin
  t:=getTickCount;
  CheckActive;
  if fReadOnly or (csDesigning in ComponentState) then
    raise eBinaryDataSetError.Create ('Dataset must be opened for read/write to perform sort.');
//  if _DataHdr.DeletedCount > 0 then
//    begin
//      Close;
//      PackTable;
//      Open;
//    end;
  QSort(_DataHdr.RecCount);
  First;
  ShowMessage(intToStr(t-GetTickCount));
end;

Internal buffer layout:
+------------------------+------------------------+---------------------------+
|     RECORD DATA        |     My Information     |     Calculated Fields     |
| SizeOf(TARecord) bytes |  SizeOf(TMyInfo) bytes |    CalcFieldSize bytes    |
+------------------------+------------------------+---------------------------+
                       ^                        ^
                  StartMyInfo            StartCalculated

function TDbf._GetFileName(f:string):string;
var
  ff:string;
begin
  if FileExists(f) then result:=f
  else begin
    else result:='';
  end;
end;

*)

{
  rMdxTag = record
    pageno      : longword; // 0..3
    tagname      : array [0..11] of byte; // 4..14
    keyformat    : byte; // 15
    forwardTag1  : byte; // 16
    forwardTag2 : byte; // 17
    backwardTag : byte; // 18
    dummy       : byte; // 19
    keytype     : byte; // 20
  end;

  rMdxTagHdr = record
    RootPage        : longint;// 0..3
    FilePages        : longint;// 4..7
    KeyFormat        : byte;   // 8
    KeyType          : byte;   // 9
    dummy            : word;   // 10..11
    IndexKeyLength   : word;   // 12..13
    MaxNbKeys       : word;   // 14..15
    SecondKeyType   : word;   // 16..17
    IndexKeyItemLen  : word;   // 18..19
    dummy2           : array [20..22] of byte;
    UniqueFlag      : byte;   // 23
  end;
}


(*
  TDbfIndex = class
  protected
    MdxTag : rMdxTag;
    MdxTagHdr : rMdxTagHdr;
//    _dbf: TDbf;
    _buffsize: integer;
    _pagesize: integer;
  public
    constructor Create;
//    procedure Init(Owner:TDbf);
    destructor Destroy; override;
    procedure Test;
    procedure Lire(Page:integer);
  end;
*)
(*
procedure TDbfIndex.Init(Owner:TDbf);
begin

  _dbf:=Owner;
  // seems stupid... not easy to understand some field's purpose.
  _buffsize:=_dbf._IndexHdr.BlockAdder;
  _pagesize:=_buffsize div _dbf._IndexHdr.BlockSize;
end;

procedure TDbfIndex.Test;
begin
//  _dbf._TempIndex.clear;
  Lire(MdxTagHdr.RootPage);
//  _dbf.Refresh;
end;

procedure TDbfIndex.Lire(Page:integer);
type

  rIdxNode = record
    DataRecordNumber : longword;
    KeyData : array[0..507] of char; // run-time defined real length...
  end;
  pIdxNode = ^rIdxNode;

  rIdxPage = record
    NoEntry : longword;
    LowLevel : longword;
    IdxNodes : rIdxNode; // run-time defined real length...
  end;
  pIdxPage = ^rIdxPage;

var
  i:integer;
  BlockNo:integer;
  IdxPage:pIdxPage;
  IdxNode:pIdxNode;
  _buff:pchar;
begin
  _buff:=StrAlloc(_buffsize+1);
  try
    while Page>0 do begin
      BlockNo := Page * _pagesize;
//      _dbf._indexStream.Seek(BlockNo  ,0);
//      _dbf._indexStream.ReadBuffer(_buff^,_buffsize);
      IdxPage:=pIdxPage(_buff);
      if IdxPage.NoEntry>0 then begin
        for i:=0 to IdxPage.NoEntry-1 do begin
          //
          IdxNode:=pIdxNode(PIdxNode(Integer(@IdxPage.IdxNodes.DataRecordNumber) + i * (MdxTagHdr.IndexKeyLength+4)));
          //if IdxNode.DataRecordNumber>0 then Lire(IdxNode.DataRecordNumber);
          // _dbf._ReadRecord(_dbf.ActiveBuffer,IdxNode.RecNo);

          _dbf._TempIndex.Add(Pointer(IdxNode.DataRecordNumber - 1));
          //  if IdxNode.<>0 then begin
          //  Lire(IdxNode.NextPg);
        end;
      end; // if
      Page := IdxPage.LowLevel;
    end; // while
  finally
    strdispose(_buff);
  end;

end;

    _IndexHdr : rMultipleIndexHdr;
    _DataHdr : rFileHdr;
    _MemoHdr : rMemoHdr;
  Result:= _DataHdr.VerDBF and 7;
*)
(*

  if (DBFVersion) >=4 then begin
    _dataStream.SetHdr(SizeOf(rAfterHdrV4) + SizeOf(rFileHdr),SizeOf(rFieldHdrV4));
  end else begin
    _dataStream.SetHdr(SizeOf(rAfterHdrV3) + SizeOf(rFileHdr),SizeOf(rFieldHdrV3));
  end;

    _dataStream.SetHdr(sizeof(_DataHdr),0);
    _dataStream.ReadHeader(_DataHdr);

*)
(*
// ____________________________________________________________________________
// TDbf.PackTable
//Enhancement: Remove all deleted items from the table.
Procedure TDbf.PackTable;
var
  NewStream, OldStream : tStream;
  PC : PChar;
  Ix : Integer;
//  lFieldHdrV3 : rFieldHdrV3;
//  lFieldHdrV4 : rFieldHdrV4;

  NewFileHdr : rFileHdr;
//  NewAfterHdrV3 : rAfterHdrV3;
//  NewAfterHdrV4 : rAfterHdrV4;
  DataBuffer : Pointer;
begin

  OldStream := Nil;
  NewStream := Nil;
  CheckInactive;

  if fTableName = '' then
    raise EBinaryDataSetError.Create('Table name not specified.');
  if not FileExists (FTableName) then
    raise EBinaryDataSetError.Create('Table '+fTableName+' does not exist.');
  PC := @fTablename[1];
  CopyFile(PChar(PC),PChar(PC+',old'+#0),False);
  // create the new file
  if FieldDefs.Count = 0 then
  begin
    for Ix := 0 to _FieldCount - 1 do
    begin
      with Fields[Ix] do
      begin
        if FieldKind = fkData then
          FieldDefs.Add(FieldName,DataType,Size,Required);
      end;
    end;
  end;
  try
    NewStream := TFileStream.Create (FTableName+',new',
      fmCreate or fmShareExclusive);
    OldStream := tFileStream.Create (fTableName+',old',
      fmOpenRead or fmShareExclusive);
    OldStream.ReadBuffer(NewFileHdr,SizeOf(rFileHdr));
    if (NewFileHdr.VerDBF and 7)<=3 then begin
      OldStream.ReadBuffer(NewAfterHdrV3,SizeOf(rAfterHdrV3));
    end else begin
      OldStream.ReadBuffer(NewAfterHdrV4,SizeOf(rAfterHdrV4));
    end;
    NewStream.WriteBuffer(NewFileHdr,SizeOf(rFileHdr));
    if (NewFileHdr.VerDBF and 7)<=3 then begin
      NewStream.WriteBuffer(NewAfterHdrV3,SizeOf(rAfterHdrV3));
    end else begin
      NewStream.WriteBuffer(NewAfterHdrV4,SizeOf(rAfterHdrV4));
    end;

    for IX := 0 to _FieldCount-1 do
      begin
        if (DBFVersion)>=4 then begin
          OldStream.Read(lFieldHdrV4,SizeOf(lFieldHdrV4));
          NewStream.Write(lFieldHdrV4,SizeOf(lFieldHdrV4));
        end else begin
          OldStream.Read(lFieldHdrV3,SizeOf(lFieldHdrV3));
          NewStream.Write(lFieldHdrV3,SizeOf(lFieldHdrV3));
        end;
      end;
    GetMem(DataBuffer,NewFileHdr.RecordSize);
    REPEAT
      IX := OldStream.Read(DataBuffer^,NewFileHdr.RecordSize);
      if (IX = NewFileHdr.REcordSize) and (pRecordHdr(DataBuffer)^.DeletedFlag = ' ') then
        NewStream.WRite(DataBuffer^,NewFileHdr.RecordSize);
    Until IX <> NewFileHdr.RecordSize;
    FreeMem(DataBuffer,NewFileHdr.RecordSize);
  finally
    // close the file
    NewStream.Free;
    OldStream.Free;
  end;
  CopyFile(PChar(PC+',new'+#0),PChar(PC),False);
  DeleteFile(Pchar(PC+',new'+#0));
  DeleteFile(Pchar(PC+',old'+#0));

end;
*)
// ____________________________________________________________________________

// ____________________________________________________________________________
// TDbf._CompareRecords
// Compare two records.  Returns -1 if REC1 < REC2, 0 if REC1 = REC2, or
// 1 if REC1 > REC2.
(*
Function TDbf._CompareRecords(SortFields:Array of String;Rec1,Rec2:Integer):Integer; FAR;
{-Compare the records Rec1, Rec2 and return -1 if Rec1 < Rec2, 0 if Rec1 = Rec2,
  1 if Rec1 > Rec2 }
VAR
  IX : Integer;

  Function CompareHelper(KeyId:String;Rec1,Rec2:Integer):Integer;
  VAR
    SKey1, SKey2 : String;
    IKey1, IKey2 : Integer;
    fKey1, fKey2 : Double;
    dKey1, dKey2 : tDateTime;
    CompareType : tFieldType;
    KeyField : tField;
  begin
    KeyField := FieldByName(KeyID);
    CompareType := KeyField.DataType;
    Case CompareType of
      ftFloat,
      ftCurrency,
      ftBCD :
        begin
          _dataStream.ReadRecord(ActiveBuffer^,Rec1-1);
          fKey1 := KeyField.AsFloat;
          _dataStream.ReadRecord(ActiveBuffer^,Rec2-1);
          fKey2 := KeyField.AsFloat;
          if fKey1 < fKey2 then
            Result := -1
          else
            if fKey1 > fKey2 then
              Result := 1
            else
              Result := 0;
        end;
      ftSmallInt,
      ftInteger,
      ftWord :
        begin
          _dataStream.ReadRecord(ActiveBuffer^,Rec1-1);
          IKey1 := KeyField.AsInteger;
          _dataStream.ReadRecord(ActiveBuffer^,Rec2-1);
          IKey2 := KeyField.AsInteger;
          if IKey1 < IKey2 then
            Result := -1
          else
            if IKey1 > IKey2 then
              Result := 1
            else
              Result := 0;
        end;
      ftDate,
      ftTime,
      ftDateTime :
        begin
          _dataStream.ReadRecord(ActiveBuffer^,Rec1-1);
          dKey1 := KeyField.AsDateTime;
          _dataStream.ReadRecord(ActiveBuffer^,Rec2-1);
          dKey2 := KeyField.AsDateTime;
          if dKey1 < dKey2 then
            Result := -1
          else
            if dKey1 > dKey2 then
              Result := 1
            else
              Result := 0;
        end;
      else
        begin
          _dataStream.ReadRecord(ActiveBuffer^,Rec1-1);
          SKey1 := KeyField.AsString;
          _dataStream.ReadRecord(ActiveBuffer^,Rec2-1);
          SKey2 := KeyField.AsString;
          if SKey1 < SKey2 then
            Result := -1
          else
            if SKey1 > SKey2 then
              Result := 1
            else
              Result := 0;
        end;
    end;
  end;
begin
  IX := 0;
  REPEAT // Loop through all available sortfields until not equal or no more sort fiels.
    Result := CompareHelper(SortFields[IX],Rec1,Rec2);
    Inc(IX);
  UNTIL (Result <> 0) or (IX > High(SortFields));
end;


Procedure TDbf._SwapRecords(Rec1,REc2:Integer);
VAR
  Buffer1, Buffer2 : PChar;
  Bookmark1, BOokmark2 : TBookmarkFlag;
begin
  Rec1 := Rec1 - 1;
  Rec2 := Rec2 - 1;
  if Rec1 < 0 then Exit;
  if Rec2 < 0 then Exit;
  Buffer1 := AllocRecordBuffer;
  Buffer2 := AllocRecordBuffer;
  _dataStream.ReadRecord(Buffer1^,Rec1);
  _dataStream.ReadRecord(Buffer2^,Rec2);
  Bookmark1 := GetBookmarkFlag(Buffer1);
  Bookmark2 := GetBookmarkFlag(Buffer2);
  SetBookmarkFlag(Buffer1,Bookmark2);
  SetBookmarkFlag(Buffer2,Bookmark1);
  _dataStream.WriteRecord(Buffer1^,Rec2);
  _dataStream.WriteRecord(Buffer2^,Rec1);
  StrDispose(Buffer1);
  StrDispose(Buffer2);
end;
*)
(*


Procedure TDbf.Test(Column:integer);
begin
//  if Column<_Indexes.Count then TDbfIndex(_Indexes[Column]).Test;
end;

Procedure TDbf.FSortTable(Column:integer);
  { This is a test of a new crap sorting routine.
    works only in ram.
    No real swap.
  }
//var
//  sl:TStringList;
//  i:integer;
//  t:longint;
begin
  CheckActive;
  if fReadOnly or (csDesigning in ComponentState) then
    raise eBinaryDataSetError.Create ('Dataset must be opened for read/write to perform sort.');

  t:=getTickCount;
  try
    sl:=TStringList.Create;
    sl.Capacity:=_DataHdr.RecCount;
    for i:=0 to _DataHdr.RecCount-1 do begin
      _dataStream.ReadRecord(ActiveBuffer^,i);
      sl.AddObject(Fields[Column].AsString,Pointer(i));
    end;
    sl.sorted:=true;

    _TempIndex.Clear;
    _TempIndex.Capacity:=sl.count;
    for i:=0 to sl.Count-1 do begin
      _TempIndex.Add(sl.Objects[i]);
    end;

  finally
    sl.free;
  end;
  First;
  Refresh;

end;
// ____________________________________________________________________________
// TDbf.UnsortTable
// Used to help test the sort routine.  Attempts to generate a random
// dispersment of the records in the dataset.
Procedure TDbf.UnsortTable;
//Var
//  IX : Integer;
begin
  First;
  Randomize;
  for IX := 0 to _DataHdr.RecCount-1 do
    begin
      _SwapRecords(IX,Random(_DataHdr.RecCount));
    end;
  First;
end;
//    Function  _CompareRecords(SortFields:Array of String;Rec1,Rec2:Integer):Integer;
//    procedure _SwapRecords(Rec1,REc2:Integer);
//    Procedure FSortTable(Column:integer);
//    Procedure Test(Column:integer);
//    Procedure UnsortTable;
*)

